#include <stdio.h>
#include "SUN_error.h"


/*	main()
*
*	the format Adapter for SunOS 4.1.0
*
*/
main(argc, argv)
int argc;
char *argv[];
{
	int rc;
	int fdout;
	char *rec;
	char *progname;
	char c, *option;

	progname = *argv;
	if (argc < 2 || argc > 4) {
		fprintf(stderr, "%s: incorrect argument count\n", progname);
		exit(1);
	}
	argv++;
	argc--;
	if ((fdout = creat_NADF(*argv)) < 0) {		
		fprintf(stderr, "%s: cannot create: %s: %d\n", progname, *argv, fdout);
		exit(1);
	}
	if ((rc = vopen(--argc, ++argv)) != 0) {
		fprintf(stderr, "%s: cannot open stdin: %d\n", progname, rc);
		exit(1);
	}
	rc = vread(&rec);
 	while (rc != SUNEOF && rc != SUNTRAILER) {
		if ((rc = write_NADF(fdout, rec, 1)) != 0) {	
			fprintf(stderr, "cannot write: %d\n",  rc);
			exit(1);
		}
		rc = vread(&rec);
	}
	if (rc == SUNTRAILER) {
		if ((rc = write_NADF(fdout, rec, 1)) != 0) {	
			fprintf(stderr, "cannot write: %d\n",  rc);
			exit(1);
		}
	} else if (rc != SUNEOF) {
		fprintf(stderr, "error: %d\n", rc);
		exit(1);
	}
	if ((rc = close_NADF(fdout)) != 0) {
		fprintf(stderr, "%s: cannot close nadf file %s\n", progname, *argv);
		exit(1);
	}
	if ((rc = vclose()) != 0) { 
		fprintf(stderr, "%s: cannot close native file\n", progname);
		exit(1);
	}

	return;
}
	
	
