
/**************************************************/
/*  						  */
/*               L'adaptateur de format           */
/*						  */
/**************************************************/ 

/**************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
 
/* */

char c;
char lec[10];
char s[15];
char tb[15];
char hex[15];
char v[1500];
char aux[25];
char dat[25];
char cod[25];
char tab[25];

FILE *fd2;

/* */

int n;
int l;
int tl;
int d;

struct enreg 
  {
    unsigned short int n;
    unsigned short int l;
    char v[1500];
    struct enreg *next;
  }  ;

char *ptr_rec;

int conv_adr_ip ();
int lire_n_hexa ();
int conv_hex ();
long trt_udp();
long trt_tcp ();
int ecrire_buf ();
int trt_paquet ();

/**************************************************/
/**************************************************/
main(argc, argv)
int argc;
char **argv;
{
int fd1;
int rc1;

/*   */


int trouve = 0;
int bool = 0;
char c;
char mot[15];
char l[4];
extern char lec[];
extern char tab[];

/* */

ptr_rec = malloc (4096);

		/* L'ouverture du fichier de traces qui va etre converti en un
		   fichier de format NADF  */

fd2 = fopen (argv[1], "r");
printf("fd2 = %d\n", fd2);
if (fd2 == 0)
  {
    printf("%s : IMPOSS D'OUVRIR %s\n", argv[0], argv[1]);
    exit(1);
  }


		/* Appel de la fonction predefinie creat_NADF pour la creation
		   du fichier NAFDF */

fd1 = creat_NADF (argv[2]);
printf("fd1 = %d\n", fd1);
if(fd1 < 0)
  {
    printf("%s : IMPOSS DE CREER %s\n", argv[0], argv[2]);
    exit(1);
  }

strcpy(l,"");

c = fscanf (fd2, "%s", mot);
while (c != EOF) {

		/* Positionnement sur les deux premiers hexa du premier paquet
		   du fichier des traces  */

  if ((bool != 1) && (strlen(mot) == 2) 
      && (((mot[0] <= '9') && (mot[0]>='0')
	   || (mot[0] <= 'f') && (mot[0] >= 'a'))
	  && ((mot[1] <= '9') && (mot[1]>='0')
	      || (mot[1] <= 'f') && (mot[1] >= 'a'))))
    {
      strcpy (l, mot);
      bool = 1;
    }
  else {
    if ((bool == 1) && (strlen(mot) == 2) && (c != EOF)
	&& (((mot[0] <= '9')
	     && (mot[0] >='0')|| (mot[0] <= 'f')
	     && (mot[0] >= 'a'))&& ((mot[1] <= '9')
				    && (mot[1]>='0')|| (mot[1] <= 'f')
				    && (mot[1] >= 'a'))))
      trouve = 1;
    else (bool = 0);
  }
  if (trouve == 1){

		/* Traitement du paquet */

    trt_paquet(fd1, l, mot);
    
    do {
      c = fscanf(fd2, "%s", mot);
    } while ((strlen(mot) == 2) && (c != EOF));
    
    trouve = 0;
    bool = 0;
  }
  c = fscanf (fd2, "%s", mot);
}

fclose (fd2);
rc1 = close_NADF (fd1);
printf("rc1 = %d\n", rc1);
free (ptr_rec);
}
/**************************************************/
/**************************************************/

struct enreg *mallocEnreg()
{
/* Allocation de la memoire pour la creation d'une cellule de la chaine */

	/* 	*/
	struct enreg *ptr;
 
	ptr = (struct enreg *) malloc (sizeof(struct enreg)  );
	ptr->n = 0;
	ptr->l = 0;
	strcpy(ptr->v, "");
	return(ptr);
}
/**************************************************/

lire_n_hexa (d, tb)
int d;
char tb[];
{
/* construit le tableau tb avec les d hexadecimaux qu'elle lit */

int i;
char m[25];

strcpy (tb, "");
for (i = 0;i < d;i++){
    fscanf (fd2, "%s", m);
    strcat (tb, m);
    strcat (tb, " ");
}
}
/**************************************************/

int conv_hex (hex)
char hex[];
{
/* Convertion, recoit un hexadecimal et retourne un entier */

int val;

if ((hex[0] <= '9') && (hex[0] >= '0'))
   val = hex[0] - '0';

else if ((hex[0] <='f') && (hex[0] >= 'a'))
	val = hex[0] - 'a' + 10;

else if ((hex[0] <='F') && (hex[0] >= 'A'))
	val = hex[0] - 'A' + 10;
else {
	printf("non hexa string %s\n", hex);
	return 0;
}

if ((hex[1] <= '9') && (hex[1] >= '0'))
   val = val * 16 + hex[1] - '0';

else if ((hex[1] <= 'f') && (hex[1] >= 'a'))
	val = val * 16 + hex[1] - 'a' + 10;
else if ((hex[1] <='F') && (hex[1] >= 'A'))
   val = val * 16 + hex[1] - 'A' + 10;
else {
	printf("non hexa string %s\n", hex);
	return 0;
}

return (val);
}
/**************************************************/

conv_adr_ip (n, aux)
int n;
char aux[];
{
/* recoit un hexa, le convertit, le met sous forme d'entiers dans le tableau
   aux, ces entiers sont separes par des points */

int i;
int IP[4];
char tb[3];
char tab[5];

strcpy (aux, "");

for (i = 0;i < n;i++){
  lire_n_hexa (1, tb);
  IP[i] = conv_hex (tb);
}

for (i = 0;i < 4;i++){
  sprintf (tab, "%d", IP[i]);
  strcat (aux, tab);
  if (i < 3)
    strcat (aux, ".");
}
strcat (aux, " ");
}
/**************************************************/

long trt_udp(fin)
struct enreg *fin;
{
/* lit dans le fichier de traces, traite l'information lue, qui est le paquet udp */

int  port;
int i;
int len;
int ld;
int lt = 0;
char tab[4];
char inter[1000];
char t[1000];
char don_cod[1000];

struct enreg *ptr_courant, *mallocEnreg();

/* UDP */
/*******/
/*******/

/* SP */

ptr_courant =mallocEnreg();
ptr_courant->n = 316;
lire_n_hexa (1, tab);
port = conv_hex (tab);
lire_n_hexa (1, tab);
port = port * 256 + conv_hex (tab);
sprintf (ptr_courant->v, "%d", port);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;


/* DP */

ptr_courant =mallocEnreg();
ptr_courant->n = 317;
lire_n_hexa (1, tab);
port = conv_hex (tab);
lire_n_hexa (1, tab);
port = port * 256 + conv_hex (tab);
sprintf (ptr_courant->v, "%d", port);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;


fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;


/* Length of UDP */

ptr_courant =mallocEnreg();
ptr_courant->n = 318;
lire_n_hexa (1, tab);
ld = conv_hex (tab);
lire_n_hexa (1, tab);
ld = ld * 256 + conv_hex (tab);
sprintf (ptr_courant->v, "%d", len);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Checksum */

ptr_courant =mallocEnreg();
ptr_courant->n = 319;
lire_n_hexa (2, ptr_courant->v);
ptr_courant->l= strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

ld = ld - 8;

/* Data */

ptr_courant =mallocEnreg();
ptr_courant->n = 320;
if (ld != 0)
  {
    for (i = 1;i <= ld; i++)
      {

	lire_n_hexa (1, t);
	strcat(ptr_courant->v, t);
      }

    ptr_courant->l = strlen (ptr_courant->v);
    lt = lt + 4 + ptr_courant->l;
  }
else
{
  lt = lt + 4;
  ptr_courant->l = 0;
}
fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

return (lt);

}
/**************************************************/

long trt_tcp (fin, ld)
struct enreg *fin;
int ld;
{
/* lit dans le fichier de trace, traite l'information lue, qui est le paquet
   tcp, remplit les champs du protocole utilise est tcp  */

int port;
int Hlen = 0;
int i;
char inter[500];
char aux[1000];
char t[1000];
char don_cod[1000];
struct enreg *mallocEnreg();

/* */ 

struct enreg *ptr_courant;
long lt = 0;

/* TCP */
/*******/
/*******/

/* SP */

ptr_courant =mallocEnreg();
ptr_courant->n = 216;
lire_n_hexa (1, inter);
port = conv_hex (inter);
lire_n_hexa (1, inter);
port = port * 256 + conv_hex (inter);
sprintf (t, "%d", port);
strcat (t, " ");
strcpy (ptr_courant->v, t);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* DP */

ptr_courant =mallocEnreg();
ptr_courant->n = 217;
lire_n_hexa (1, inter);
port = conv_hex (inter);
lire_n_hexa (1, inter);
port = port * 256 + conv_hex (inter);
sprintf (t, "%d",port);
strcat (t, " ");
strcpy (ptr_courant->v, t);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* SeqN */

ptr_courant =mallocEnreg();
ptr_courant->n = 218;
lire_n_hexa (4, ptr_courant->v);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* AckN */

ptr_courant =mallocEnreg();
ptr_courant->n = 219;
lire_n_hexa (4, inter);
ptr_courant->l = strlen (inter);
strcpy (ptr_courant->v, inter);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Off = HL */

ptr_courant =mallocEnreg();
ptr_courant->n = 220;
lire_n_hexa (1, inter);
strcpy (aux, inter);
inter[1] = '\0';
strcat (inter, " ");
strcpy (ptr_courant->v, inter);
Hlen = (atoi(inter)) * 4;

ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Res */

ptr_courant =mallocEnreg();
ptr_courant->n = 221;
inter[0] = aux[1];
strcat (inter, " ");
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Code */

ptr_courant =mallocEnreg();
ptr_courant->n = 222;
lire_n_hexa (1, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Win */

ptr_courant = mallocEnreg();
ptr_courant->n = 223;
lire_n_hexa (1, inter);
port = conv_hex (inter);
lire_n_hexa (1, inter);
port = port * 256 + conv_hex (inter);
sprintf (t, "%d", port);
strcat (t, " ");
strcpy (ptr_courant->v, t);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* Chk */

ptr_courant =mallocEnreg();
ptr_courant->n = 224;
lire_n_hexa (2, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* UP */

ptr_courant =mallocEnreg();
ptr_courant->n = 225;
lire_n_hexa (2, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + (ptr_courant->l);

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;
				/* traitement du champ option */
/* Options (s'il y en a) */
if (Hlen != 20)
  {
    ptr_courant =mallocEnreg();
    ptr_courant->n = 226;
    lire_n_hexa (Hlen - 20, inter);
    strcpy (ptr_courant->v, inter);
    ptr_courant->l = strlen (ptr_courant->v);
    lt = lt + 4 + (ptr_courant->l);

    fin->next = ptr_courant;
    ptr_courant->next = NULL;
    fin = ptr_courant;
  }
ld  = ld - Hlen;


/* Data */
/********/

ptr_courant =mallocEnreg();
ptr_courant->n = 227;
if (ld != 0)
  {
    for (i = 1;i <= ld; i++)
      {

	lire_n_hexa (1, t);
	strcat(ptr_courant->v, t);
      }

    ptr_courant->l = strlen (ptr_courant->v);
    lt = lt + 4 + ptr_courant->l;
  }
else
{
  lt = lt + 4;
  ptr_courant->l = 0;
}

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

return (lt);  

}
/**************************************************/

ecrire_buf (lt, debut)
int lt;
struct enreg *debut;

{
/* Lit les donnees de la liste chainee et les ecrit dans un buffer qui sera 
   par la suite copie dans le fichier nadf par une fonction predefinie  */

struct enreg  *ptr_courant, *tmp;
int *ptr_lg;
unsigned short *ptr_id;
unsigned short *ptr_l;
char *ptr_rec_cour;

ptr_lg = (int *) ptr_rec;
ptr_rec_cour = ptr_rec + sizeof(int);

ptr_courant = debut;
do {
	if (ptr_courant->n == 320) {
		debut = debut;
	}

if ((ptr_courant->l) % 2 != 0) {
  ptr_courant->l = ptr_courant->l + 1;
  strcat (ptr_courant->v, " ");
  lt++;
}
ptr_id = (unsigned short *) ptr_rec_cour;
*ptr_id = ptr_courant->n;

ptr_rec_cour = ptr_rec_cour + sizeof(unsigned short);
ptr_l = (unsigned short *) ptr_rec_cour;
*ptr_l = ptr_courant->l;

ptr_rec_cour = ptr_rec_cour + sizeof(unsigned short);
copy_bytes (ptr_courant->v, ptr_rec_cour, ptr_courant->l);
ptr_rec_cour = ptr_rec_cour + ptr_courant->l;

tmp = ptr_courant;
ptr_courant = ptr_courant->next;
free(tmp);

} while (ptr_courant != NULL);
*ptr_lg = lt;
}
/**************************************************/

/****************************************************/

trt_paquet  (fd1, lec, tab)
char lec[];
char tab[];
int fd1;

{
/*lit d'abord les premiers champs du fichier de traces genere par etherfind, 
  les traite puis les stocke dans une liste chainee, quand elle arrive au 
  champ protocole, elle traite udp ou tcp selon le protocole trouve, enfin 
  elle ecrit tous les champs se trouvant dans la chaine, dans le fichier 
  NADF par l'intermediaire d'un buffer */

unsigned short flush = 1;
int rc;
long lt = 4;
long lg;
int ld;
int c;
int leng;
int i;
int Hlen;
int proto = 0;
char t[30];
char inter[25];
char pass[25];

/* */
 
extern char aux[];

struct enreg  *ptr_courant, *debut, *fin, *tmp;
struct enreg  *mallocEnreg();

/* remplissage du premier enregistrement et ensuite des enregistrements
   restants, l'ecriture dans le fichier NADF est a la fin de la fonction */

/* DA */

debut = mallocEnreg();
debut->n = 111;
strcpy (aux, "");
strcat (aux, lec);
strcat (aux, " ");
strcat (aux, tab);
strcat (aux, " ");
lire_n_hexa (4, inter);
strcat (aux, inter);
debut->l= strlen(aux);
lt = lt + 4 + debut->l;
strcpy (debut->v, aux);

debut->next = NULL;
fin = debut;


/* SA */

ptr_courant =mallocEnreg();
ptr_courant->n = 112;
lire_n_hexa (6, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l= strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* FT */

ptr_courant =mallocEnreg();
ptr_courant->n = 113;
lire_n_hexa (2, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l= strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* IP */
/******/
/******/
/* Ver */

ptr_courant =mallocEnreg();
ptr_courant->n = 114;
lire_n_hexa (1, inter);
strcpy (pass, inter);
inter[1] = '\0';
strcat (inter, " ");
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen(ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant; 
ptr_courant->next = NULL;
fin = ptr_courant;

/* HL */

ptr_courant = mallocEnreg();
ptr_courant->n = 115;
inter[0] = pass[1];
strcat (inter, " ");
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;


pass[0] = '0';
Hlen = conv_hex (pass) * 4;

/* ST */

ptr_courant =mallocEnreg();
ptr_courant->n = 116;
lire_n_hexa (1, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* TL */

ptr_courant=mallocEnreg();
ptr_courant->n = 117;
lire_n_hexa (1, inter);
leng = conv_hex (inter);
strcpy (aux, inter);
lire_n_hexa (1, inter);
leng = leng * 256 + conv_hex (inter);
strcat (aux, inter);
strcpy (ptr_courant->v, aux);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

ld = leng - Hlen;

/* ID *** FLAGS * FRAGMENT OFFSET */

for (i = 118;i < 120;i++)
{
   ptr_courant=mallocEnreg();
   ptr_courant->n = i;
   lire_n_hexa (2, inter);
   strcpy (ptr_courant->v, inter);
   ptr_courant->l = strlen (ptr_courant->v);
   lt = lt + 4 + ptr_courant->l;
   
   
   fin->next = ptr_courant;
   ptr_courant->next = NULL;
   fin = ptr_courant;

}

/* Time *** Proto*/

for (i = 120;i < 122;i++)
{
   ptr_courant=mallocEnreg();
   ptr_courant->n = i;
   lire_n_hexa (1, inter);
   strcpy (ptr_courant->v, inter);
   ptr_courant->l = strlen (ptr_courant->v);
   lt = lt + 4 + ptr_courant->l;
   
   fin->next = ptr_courant;
   ptr_courant->next = NULL;
   fin = ptr_courant;
}

if ((inter[0] == '0') && (inter[1] == '6'))
	proto = 1;
else if ((inter[0] == '1') && (inter[1] == '1'))
     proto = 2;
     else proto = 3;

/* Hchk */

ptr_courant=mallocEnreg();
ptr_courant->n = 122;
lire_n_hexa (2, inter);
strcpy (ptr_courant->v, inter);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* IPS */

ptr_courant=mallocEnreg();
ptr_courant->n = 123;
conv_adr_ip (4, t);
strcpy (ptr_courant->v, t);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;
   
fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* IPD */

ptr_courant=mallocEnreg();
ptr_courant->n = 124;
conv_adr_ip  (4, t);
strcpy (ptr_courant->v, t);
ptr_courant->l = strlen (ptr_courant->v);
lt = lt + 4 + ptr_courant->l;

fin->next = ptr_courant;
ptr_courant->next = NULL;
fin = ptr_courant;

/* IP OPTION (s'il y en a) */

if (Hlen != 20)
{
  ptr_courant=mallocEnreg();
  ptr_courant->n = 125;
  lire_n_hexa (Hlen - 20, inter);
  strcpy (ptr_courant->v, inter);
  ptr_courant->l = strlen (ptr_courant->v);
  lt = lt + 4 + ptr_courant->l;

  fin->next = ptr_courant;
  ptr_courant->next = NULL;
  fin = ptr_courant;
}

if (proto == 1)
	lg = trt_tcp  (fin, ld);
else if (proto == 2)
	lg = trt_udp (fin);
     else 
{
  ptr_courant = debut;
  tmp = ptr_courant;
  ptr_courant = ptr_courant->next;
  free (tmp);
}


/* ecriture dans le fichier nadf */

lt = lt + lg;
ecrire_buf (lt, debut);
if ((rc = write_NADF (fd1, ptr_rec, flush)) != 0)
	printf("unable to write NADF record %d\n", rc);

}

/****************************************************/

static copy_bytes(from, to, n)
char *from, *to;
int n;

{

/* copie les n bytes d'une zone "from" a une zone "to" */ 

   while (n > 0) {
        *to++ = *from++;
         n--;
    }
}
/****************************************************/
