
/**************************************************/
/*  						  */
/*         La routine C "display_net"             */
/*						  */
/**************************************************/ 


#include <stdio.h>
#include <stdlib.h>
#include "asaxlib.h"


#include "nadf.tab.net.h"
		/* Table de correspondance des identifiants ainsi que leurs 
		   types  */
typedef void *hole;

#define TAILLE 2000

/* */

void *display_net(m)
char *m;
{
    display_net1(Curr_Rec_Addr);
    printf("\n");
}

/* */

display_net1(rec_addr)
char *rec_addr;
{
    int nb;
    short len;
    short id;
    int  type;
    int i;
    int j;
    int k;
    unsigned char *pa, c;
    char  buf[TAILLE];			
    char  *rec_cur_ptr;
    int   *rec_len_ptr;
    short *shp, *rec_sht_ptr;
    long int *rec_longInt_ptr;
    char  *ctime(), *pstr, *pstr1;

/* */

  rec_len_ptr = (int *) rec_addr;
  rec_cur_ptr = rec_addr + 4;

		/* Convertion des pointeurs et leurs positionnements au debut
		   de l'enregistrement data du paquet dans le fichier NADF */


  nb = *rec_len_ptr - 4;
  while (nb >0)
              {
                shp = rec_sht_ptr = (short *) rec_cur_ptr;
                id = *rec_sht_ptr;
		printf("\n");

		/* Test des identifiants  */

		if ( (id >= 111) && (id <= 125)) {
			printf("%s[", nadf_tab1[id - 111].ndata_name);
			type = nadf_tab1[id - 111].ndata_typ;
			}
		else  if ( (id >= 216) && (id <= 227)) {
			printf("%s[", nadf_tab2[id - 216].ndata_name);
			type = nadf_tab2[id - 216].ndata_typ;
			}
		      else  if ( (id >= 316) && (id <= 320)) {
				if (id >= 319) 
					id = id;
				printf("%s[", nadf_tab3[id - 316].ndata_name);
				type = nadf_tab3[id - 316].ndata_typ;
				}
                
		printf("%-4d, ", id);

		/* Avancement des pointeurs et lecture de la longueur du champ
		   valeur pour un identifiant  */

                rec_sht_ptr++;
                len = *rec_sht_ptr;

		/* Affichage de l'identifiant, de la longueur et de la valeur
		   selon un format precis  */ 

		printf("%-2d] = ", len);
                nb = nb-4-len;
                rec_cur_ptr = rec_cur_ptr+4;
                switch(type) {
                  
		  case tshort :
		  case tint   :
		  case tlong  :
		  case tunsignedint :
		  case tunsignedshort :

                    switch(len) {
                        case 1:
                        case 2:  rec_sht_ptr = (short *) rec_cur_ptr;
				 printf("%d",*rec_sht_ptr);
                                 break;
                        case 4:  rec_len_ptr = (int *) rec_cur_ptr;
				 if (id == 2 || id == 5 || id == 122) {
					pstr = malloc(24);
					pstr1 = ctime((long *) rec_cur_ptr);
					copy_bytes(pstr1,pstr,24);
				        printf("%s", pstr);
					free(pstr);
				 } else {
                                        printf("%d",*rec_len_ptr);
                                 }
                                 break;
			case 8:  rec_longInt_ptr = (long int *) rec_cur_ptr;
 				printf("%ld",*rec_len_ptr);
                                 break;
		       default:
				 printf("integer with len <> 2, 4, 8 " );
				 break;
                                 }
                    break;

		        case tstr    :

		     if (id == 320 || id == 227) {
			int len11;		
	
			/* Appel de la sous-routine C "sub_convert" qui nous
			   retourne la donnee convertie du buffer et sa longueur
			   len11  */

			len11 = sub_conv(rec_cur_ptr, buf, len);
			buf[len11] = '\0'; 

			/* Affichage de la valeur de l'enregistrement  */

		     	printf("%s", buf);
		     } 
		    else { 
                      	copy_bytes(rec_cur_ptr,buf,len); 
			buf[len] = '\0';
		     	printf("%s", buf);
		     }
                     break;

			default:

		     pa = (unsigned char *) rec_cur_ptr;
                     i = 1;
                     while ( i <= len )
   {
                      j = 1;
                      while  ( (j <= 5) && (i <= len) )
                      {
                         k = 1;
                         while ( (k <=4) && (i <=len) )
                          {
			   c = (unsigned char) *pa;
			   if (c < 10)
			       printf("0%x",*pa);
			   else
			       printf("%x", *pa);
                           pa++;
                           i++;
                           k++;
                           }
                         j++;
                      }
		      printf("");

                     }
                     break;



                             } /* fin switch type */

		/* avancement du pointeur courant sur l'enregistrement suivant*/

                rec_cur_ptr = rec_cur_ptr+len;
		printf("  ");
                }
    }

/**************************************************/
/*  						  */
/*               La routine C "convert"           */
/*						  */
/**************************************************/ 



int conv_hex (hex)
char hex[];
{
/* Convertion, recoit un hexadecimal dans hex et retourne un entier */

int val;
/*
int i = 0;
 
if hex[i] = ' '
	i++;
*/
if ((hex[0] <= '9') && (hex[0] >= '0'))
   val = hex[0] - '0';

else if ((hex[0] <='f') && (hex[0] >= 'a'))
	val = hex[0] - 'a' + 10;

     else if ((hex[0] <='F') && (hex[0] >= 'A'))
		val = hex[0] - 'A' + 10;

	  else {
		printf("non hexa string %s\n", hex);
		exit(1);	
}


if ((hex[1] <= '9') && (hex[1] >= '0'))
   val = val * 16 + hex[1] - '0';

else if ((hex[1] <= 'f') && (hex[1] >= 'a'))
	val = val * 16 + hex[1] - 'a' + 10;

     else if ((hex[1] <='F') && (hex[1] >= 'A'))
   		val = val * 16 + hex[1] - 'A' + 10;

	  else {
		printf("non hexa string %s\n", hex);
		exit(1);	
		}

return (val);
}
/***************************************************/

sub_conv (s, t, lg)
char *s;
char *t;
int lg;

{

/* Convertir une donnee hexa pointe par s de longueur lg et la stocker dans
   la zone t et retourne sa longueur lg1  */

  int i, j, nas, lg1;
  char tab[5], *t1;        

/* */


t1 = t;	
lg1 = 0;
while ( lg >= 3) {
	for (j = 0;j < 3;j++) {
	  tab[j] = *s++;
	  lg--;
	  }

	tab[j] = '\0';
	nas = conv_hex(tab);
	if (isprint(nas)) 
		*t1 = ((char)nas);
	else {
             *t1++ = tab[0];
             *t1 =   tab[1];
	}
	t1++;
	lg1++;
	
      }

return (lg1);
}
/***************************************************/
/***************************************************/

convert (m)
char *m;
{

/* Positionnement dans la zone memoire creee pour la lecture des arguments de
   la routine C  */


hole **h;
unsigned short *sh;
int lg, lg1;
char *s, *t;

/* */

h = (hole **) m;
lg = lenstr (*h);

if (lg != 0) {

	sh = (unsigned short *) malloc (lg);

	s = (char *) *h;
	s = s + sizeof(short);

	m = m + sizeof(int);
	h = (hole **) m;

	**h = (hole) sh;
	t = (char *) sh;
	t = t + sizeof(short);

	lg1 = sub_conv (s, t, lg);
	*sh = lg1;

	}
else {
	sh = (unsigned short *) malloc (2);		
	m = m + sizeof(int);
	h = (hole **) m;
	**h = (hole) sh;
	*sh = 0;
	}

}

/***************************************************/


